package jp.gr.puzzle.npv2.sample;

import java.io.File;
import jp.gr.puzzle.npv2.core.*;

public class XMLRead {
	static int numSize;
	static int[] hint;
	static int[] hidden;
	static int[] answer;
	static int[] question;
	static int   point;
	
	static SolverMethod method = new SolverMethod();
	static BlockConstraint block;
	
	static void readFile(String filename) {
		File file = new File(filename);
		NumberPlaceFile npFile = new NumberPlaceFile();
		try {
			npFile.Load(file);
		} catch (Exception e) {
			e.printStackTrace();
			return;
		}
		numSize = npFile.getNumSize();
		hint = Utility.boolean2int(npFile.getHint());
		hidden = npFile.getHidden();
		question = npFile.getProblem();
		block = Utility.makeBlockConstraint(npFile);

		int point = (int) Evaluator.evaluate(numSize, block, question);
		System.out.println("old point " + point);
		Utility.printGrid(question, numSize);
	}
	
	public static void main(String[] args) {
		System.out.println("XMLRead  remake a question.");
		if (args.length == 0)
			return;
		readFile(args[0]);
	
		Generator generator = new Generator( numSize, hint, hidden, block );
		generator.setMethod(method);
		
		while( (question = generator.generate()) == null )
			;
		Status state = new Status( numSize, block );
		Solver.addNumbers(state, question);
		point = (int)Evaluator.evaluate( numSize, block, question);
		
		System.out.println( "new point "+point );
		Utility.printGrid( question, numSize );
	}
}