package jp.gr.puzzle.npv2.sample;

import java.io.File;
import java.util.ArrayList;
import jp.gr.puzzle.npv2.core.*;

public class XMLWrite {
	final static int numSize = 9;
	static boolean isDiagonal = false;
	static int[] hint = {
			0,0,0,0,0,0,0,0,0,
			0,1,1,0,0,0,1,1,0,
			1,0,0,1,0,1,0,0,1,
			1,0,0,0,1,0,0,0,1,
			1,0,0,0,0,0,0,0,1,
			0,1,0,0,0,0,0,1,0,
			0,0,1,0,0,0,1,0,0,
			0,0,0,1,0,1,0,0,0,
			0,0,0,0,1,0,0,0,0		};
	
	static int[] hidden = new int[numSize*numSize];
	static SolverMethod method = new SolverMethod();
	
	public static void main(String[] args) {
		System.out.println("XMLWrite");
		
		int[] problem = null;
		ArrayList<Integer[]> blockarraylist = Utility.makeNormalBlock(numSize, 3, 3 );
		BlockConstraint block = new BlockConstraint( blockarraylist, numSize);	
		Generator generator = new Generator(numSize , hint , hidden, block);
		generator.setMethod(method);

		while( (problem = generator.generate()) == null )
			;
		Status state = new Status(numSize,block);
		Solver.addNumbers( state, problem);
		Status result = Solver.answer(state , method);
		int[] answer = result.getCell();
		int[] blockarray = Utility.integer2int(block.getBlockArray());
		int point = (int)Evaluator.evaluate(numSize,block,problem);	
		
		System.out.println( "point "+point );		
		Utility.printGrid( problem, numSize );
		File file = new File( "xmlwrite.xml");
		
		NumberPlaceFile npFile = new NumberPlaceFile();
		npFile.setNumSize(numSize);
		npFile.setHint(Utility.int2boolean(hint));
		npFile.setHidden(hidden);
		npFile.setAnswer(answer);
		npFile.setDifficult(point);
		npFile.setIsDiagonal(isDiagonal);
		npFile.setBlockArray(blockarray);
		npFile.setProblem(problem);
		npFile.Save(file);		
	}
}